SystemOrganization addCategory: #'Glamour-Roassal-Presentations'!

GLMParameterizableExamplesBrowser subclass: #GLMRoassalExamplesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Presentations'!

!GLMRoassalExamplesBrowser commentStamp: 'TudorGirba 9/9/2012 02:47' prior: 0!
self new openOn: ROMondrianExample!

!GLMRoassalExamplesBrowser class methodsFor: 'instance creation' stamp: 'TudorGirba 9/9/2012 02:56'!
open 
	^ self new openOn: ROMondrianExample! !

!GLMRoassalExamplesBrowser methodsFor: 'hooks' stamp: 'TudorGirba 9/9/2012 02:46'!
exampleSelectorsFromClass: exampleClass
	^ exampleClass selectors select: [ :each | each endsWith: 'On:' ]! !

!GLMRoassalExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 5/21/2013 21:54'!
installTitle
	browser title: 'Roassal Examples'! !

!GLMRoassalExamplesBrowser methodsFor: 'hooks' stamp: 'TudorGirba 9/9/2012 02:47'!
renderedExampleIn: composer
	composer roassal
		title: 'Example';
		painting: [ :view :exampleClass :exampleSelector | exampleClass new perform: exampleSelector with: view ]! !

Object subclass: #GLMRoassalPresentationExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Presentations'!

!GLMRoassalPresentationExample methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/21/2014 22:47'!
roassalDirect
	"self new roassalDirect openOn: (1 to: 20)"

	^ GLMWrapper new with: [ :browser |
		browser show: [ :a |
			a roassal 
				initializeView: [ ROView new @ RODraggable ] ;
				painting: [	:view :numbers | 
					numbers do: [ :number | 
						view add: (ROElement spriteOn: number) + ROLabel ].
					ROTreeLayout on: view elements
				] ] ]! !

!GLMBasicExamples methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 8/20/2013 21:45'!
roassalWithCustomHighlight
	<glmBrowser: 'Roassal with custom highlight' input: '1 to: 42'>
	"self new roassalWithCustomHighlight openOn: (1 to: 42)"

	| browser |
	browser := GLMTabulator new .
	browser
		with: [:tabulator | 
			tabulator column: #index; column: #visualization.
			tabulator transmit to: #index; andShow: [:a | a list ].
			tabulator transmit to: #visualization; andShowIfNone:[ :a | 
				a roassal 
					painting: [:view :collection :roassal | 
						view shape label.
						view interaction on: ROMouseLeftClick do: [:ann | (roassal pane port: #selection) value: ann element model ].
						view nodes: collection.
						view gridLayout.
						roassal on: GLMContextChanged do: [:ann |
							ann property = #selection ifTrue: [
								ann oldValue ifNotNil: [
							ROBlink unhighlight: (ann presentation view raw elementFromModel: ann oldValue).
							ROBlink highlight: (ann presentation view raw elementFromModel: ann value) 
						]]]]].
			tabulator transmit from: #index; to: #visualization port: #selection.
			tabulator transmit from: #visualization port: #selection; to: #index port: #selection.
	].
	^ browser! !

!GLMBasicExamples methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 6/13/2012 14:56'!
roassalWithMenu
	<glmBrowser: 'Roassal with menu' input: '42'>
	"self new roassalWithMenu openOn: 42"

	| browser |
	browser := GLMTabulator withStatusbar.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		a roassal 
			title: 'Numbers in Roassal';
			painting: [:view :number | 
				view shape label.
				view interaction 
					on: ROMouseClick do:  [ :event |  
						ROFocusView new on: event element view: view raw ].
				view nodes: (1 to: number).
				view edgesFrom: [:each | each // 5 ].
				view treeLayout.
				view addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].
				view addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].
				  ]].
	^ browser! !

!GLMBasicExamples methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 10/4/2013 23:25'!
updateableIndividualPresentations
	<glmBrowser: 'Updateable individual presentations' input: '|collection|
	collection := GLMAnnouncingCollection new.
	collection add: 1; add: 2; add: 3.
	collection'>
	"
	|collection|
	collection := GLMAnnouncingCollection new.
	collection add: 1; add: 2; add: 3.
	self new updateableIndividualPresentations openOn: collection."
	
	| browser |
	browser := GLMTabulator new.
	browser column: #automatic; column: #menu.
	browser 
		act: [:b | b entity add: (b entity size + 1) ] 	
		icon: GLMUIThemeExtraIcons glamorousAdd
		entitled: 'Add an item in the collection'.
	browser 
		act: [:b | b entity removeLast ] 
		icon: GLMUIThemeExtraIcons glamorousRemove
		entitled: 'Remove last item from the collection'.
	browser 
		act: [:b | b update ] 
		icon: GLMUIThemeExtraIcons glamorousRefresh
		entitled: 'Update complete browser'.
	browser transmit to: #automatic; andShow: [ :a :x |
		a title: 'Updated automatically'.
		a stackedArrangement.
		a list title: [ 'List: ', x size printString ];
			shouldValidate: true;
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself.
		a text title: 'Text';
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself .
		a roassal title: 'Roassal';
			updateOn: GLMItemAdded from: #yourself;
			updateOn: GLMItemRemoved from: #yourself;
			painting: [:view | 
				view shape label.
				view nodes: x ] ].
	browser transmit to: #menu; andShow: [ :a :x |
		a title: 'Updated via menu'.
		a stackedArrangement.
		a list title: 'List';
			shouldValidate: true;
			act: [:p | p update] 
				icon: GLMUIThemeExtraIcons glamorousRefresh
				entitled: 'Update'.
		a text title: 'Text';
			act: [:p | p update] 
				icon: GLMUIThemeExtraIcons glamorousRefresh
				entitled: 'Update'.
		a roassal title: 'Roassal';
			act: [:p | p update]
				icon: GLMUIThemeExtraIcons glamorousRefresh
				entitled: 'Update';
			painting: [:view | 
				view shape label.
				view nodes: x ] ].
	^ browser! !

GLMScriptingEditorTemplate subclass: #GLMRoassalEasel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Presentations'!

!GLMRoassalEasel commentStamp: '<historical>' prior: 0!
This browser offers a Glamour-based Roassal Easel.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 6/5/2012 17:10'!
defaultScriptBindings
	^ {#view -> ROMondrianViewBuilder new}! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 02:56'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'view';
		morphicAct: [:text | GLMRoassalExamplesBrowser open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 5/7/2012 10:18'!
defaultTitle
	^ 'Roassal Easel'! !

!GLMRoassalEasel methodsFor: 'private' stamp: 'AndreiChis 12/19/2013 15:58'!
"protocol: private"
evaluate: script in: context for: view
	| message |
	^ [ (Smalltalk compiler requestor: self) evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			message := e class name , ': ' , e messageText.
			self inform: message.
			view shape label color: Color red lighter; withText .
			view node: message ]! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 6/5/2013 23:11'!
resultIn: a
	^ a roassal
		title: 'View';
		painting: [ :view :bindings :script | 
					| context |
					context := GLMDoItContext with: #view -> view withAll: bindings.
					self evaluate: script in: context for: view ]! !

!ROMondrianViewBuilder methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 6/30/2013 22:37'!
asBrowserWithStatusbar
	| browser |
	browser := GLMWrapper withStatusbar.
	browser title: 'Roassal painting'.
	browser show: [ :a | a roassal view: self ].
	^ browser! !

!ROMondrianViewBuilder methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 12/17/2013 20:22'!
newMorph
	^ ROPlatform current hostVisualElement on: self raw. ! !

!ROMondrianViewBuilder methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 1/19/2014 13:19'!
onMorph: aROMorph 
	aROMorph setView: self raw! !

!ROMondrianViewBuilder methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 5/31/2013 09:56'!
openWithStatusbar
	^ self asBrowserWithStatusbar openOn: self! !

!GLMCompositePresentation methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 5/5/2012 14:35'!
roassal
	^ self custom: GLMRoassalPresentation new! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassalRenderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Presentations'!

!GLMMorphicRoassalRenderer methodsFor: 'rendering' stamp: 'BenComan 11/17/2013 22:40'!
actOnPresentationUpdate: ann
	| aView |
	aView := ann presentation newViewBlock value. 
	ann presentation renderOn: aView.
	aView onMorph: myMorph ! !

!GLMMorphicRoassalRenderer methodsFor: 'rendering' stamp: 'BenComan 11/17/2013 22:40'!
render: aRoassalPresentation
	| view |
	view := aRoassalPresentation view.
	aRoassalPresentation renderOn: view.
	aRoassalPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	^ myMorph := view newMorph ! !

!ROView methodsFor: '*glamour-roassal-presentations' stamp: 'BenComan 11/18/2013 00:12'!
applyLayout
	"Do nothing except be polymorphic with ROMondrianViewBuilder."! !

!ROView methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 12/17/2013 20:21'!
newMorph
	^ ROPlatform current hostVisualElement on: self! !

!ROView methodsFor: '*glamour-roassal-presentations' stamp: 'BenComan 11/17/2013 22:23'!
onMorph: aROMorph 
	aROMorph setView: self.! !

!ROView methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 12/17/2013 22:32'!
raw
	^ self! !

GLMPresentation subclass: #GLMRoassalPresentation
	instanceVariableNames: 'painting paintingBlock view shouldPopulateSelection newViewBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Presentations'!

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 5/7/2012 12:09'!
bitmap 
	^ self view bitmap ! !

!GLMRoassalPresentation methodsFor: 'scripting' stamp: 'TudorGirba 10/13/2013 21:32'!
defaultActions
	self
		act: [ :roassal | ROExportPNGCommand new executeOn: roassal view raw ] 
			entitled: 'Export as PNG';
		act: [ :roassal | ROExportSVGCommand new executeOn: roassal view raw ] 
			entitled: 'Export as SVG';
		act: [ :roassal | ROZoomOutMove new on: roassal view raw ]
			icon: GLMUIThemeExtraIcons glamorousZoomOut
			entitled: 'Zoom out';
		act: [ :roassal | ROZoomInMove new on: roassal view raw ]
			icon: GLMUIThemeExtraIcons glamorousZoomIn
			entitled: 'Zoom in'! !

!GLMRoassalPresentation methodsFor: 'initialize-release' stamp: 'TudorGirba 12/17/2013 20:12'!
initialize 
	super initialize.
	"Hardcoded default ROMondrianViewBuilder for backward compatibility"
	newViewBlock := [ ROMondrianViewBuilder new ].
	shouldPopulateSelection := true.
	self defaultActions! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 12/17/2013 20:11'!
initializeView: aZeroArgBlock
	^ newViewBlock := aZeroArgBlock ! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 1/19/2014 12:45'!
newView
	view := nil.
	^ self view! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 12/17/2013 20:11'!
newViewBlock
	^ newViewBlock! !

!GLMRoassalPresentation methodsFor: 'scripting' stamp: 'TudorGirba 5/7/2012 14:10'!
painting: anObject
	paintingBlock := anObject! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 5/7/2012 14:10'!
paintingBlock
	^ paintingBlock! !

!GLMRoassalPresentation methodsFor: 'rendering' stamp: 'TudorGirba 5/7/2012 14:13'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassalPresentation: self! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'BenComan 11/18/2013 00:14'!
renderOn: aView
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self paintingBlock glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aView) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: aView with: self entity with: self]).
	self flag: 'This should be the responsibility of the the view'.
	aView applyLayout.	
	self shouldPopulateSelection ifTrue: [
		aView view allElementsDo: [:each |  
			each on: ROMouseClick do: [:event | self selection: each model ]] ].
	self view: aView! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/9/2012 21:09'!
shouldPopulateSelection
	"this flag tells the presentation whether clicking on some element inside
	the view should populate the selection port from the pane containing the presentation"
	^ shouldPopulateSelection! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/9/2012 20:16'!
shouldPopulateSelection: anObject
	shouldPopulateSelection := anObject! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'BenComan 11/17/2013 22:38'!
view
	^ view ifNil: [ view := self newViewBlock value ]! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 5/7/2012 14:11'!
view: anObject
	view := anObject! !
